;*---------------------------------------------------------------------*/
;*    Copyright (c) 1996 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;*=====================================================================*/
;*    serrano/prgm/project/bigloo/comptime1.8/Bivalue/cache.scm        */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Sun Feb 19 12:06:57 1995                          */
;*    Last change :  Fri Apr  7 11:56:46 1995 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The bivalution cache                                             */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module bivalue_cache
   (include "Ast/node.sch")
   (import  ast_global)
   (export  (start-bivalue-cache!)
	    *cons*
	    *car*
	    *cdr*))

;*---------------------------------------------------------------------*/
;*    Cache registers                                                  */
;*---------------------------------------------------------------------*/
(define *cons* #f)
(define *car*  #f)
(define *cdr*  #f)

;*---------------------------------------------------------------------*/
;*    start-bivalue-cache! ...                                         */
;*---------------------------------------------------------------------*/
(define (start-bivalue-cache!)
   (set! *cons* (require-global 'c-cons #f #f))
   (set! *car*  (require-global 'c-car  #f #f))
   (set! *cdr*  (require-global 'c-cdr  #f #f))
   #t)
