;*---------------------------------------------------------------------*/
;*    Copyright (c) 1996 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;*=====================================================================*/
;*    serrano/prgm/project/bigloo/comptime1.8/Cforeign/install.scm     */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Thu Dec 29 15:44:53 1994                          */
;*    Last change :  Mon Jan 29 09:37:53 1996 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The C foreign accessors and coercers installation.               */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module cforeign_install
   (include "Type/type.sch"
	    "Ast/ast.sch")
   (import  tools_error
	    tools_shape
	    parse_cforeign
	    parse_static-export
	    ast_env
	    engine_param
	    cforeign_type
	    type_env
	    cforeign_install-c-struct
	    cforeign_install-c-pointer
	    cforeign_install-c-array
	    cforeign_install-c-function
	    cforeign_install-c-enum)
   (export  (install-c-foreign-accessors!)))

;*---------------------------------------------------------------------*/
;*    install-c-foreign-accessors! ...                                 */
;*---------------------------------------------------------------------*/
(define (install-c-foreign-accessors!)
   (append (install-c-struct-accessors!)
	   (install-c-pointer-accessors!)
	   (install-c-array-accessors!)
	   (install-c-function-accessors!)
	   (install-c-enum-accessors!)))

